﻿@using Microsoft.AspNetCore.Identity
@using SecondMVCAppMy.DAL.Entities
@model SecondMVCAppMy.Models.Topics.TopicFilterAndSortModel
@inject SignInManager<User> SignInManager
@inject UserManager<User> UserManager

@{
    ViewData["Title"] = "Index";
}


<h1>Index</h1>

<div class="row">
    <div class="col-md-4">
        <form asp-action="Index" method="get">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <input type="hidden" asp-for="Page" value="@Model.Page" />
            <div class="form-group">
                <label asp-for="SearchKey" class="control-label"></label>
                <input asp-for="SearchKey" class="form-control" value="@Model.SearchKey" />
                <span asp-validation-for="SearchKey" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Author" class="control-label"></label>
                <input asp-for="Author" class="form-control" value="@Model.Author" />
                <span asp-validation-for="Author" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="DateFrom" class="control-label"></label>
                <input asp-for="DateFrom" type="date" class="form-control" value="@Model.DateFrom" />
                <span asp-validation-for="DateFrom" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="DateTo" class="control-label"></label>
                <input asp-for="DateTo" type="date" class="form-control" value="@Model.DateTo" />
                <span asp-validation-for="DateTo" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="Search" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<table id="topicTable" class="table">
    <thead>
        <tr>
            <th>
                <a asp-controller="Topic" asp-action="Index" asp-route-sortState=@Model.DateOfCreationSort
                   asp-route-сurrentPage=@Model.TopicPageModel.PageNumber
                   asp-route-page=@Model.Page
                   asp-route-searchKey=@Model.SearchKey
                   asp-route-author=@Model.Author
                   asp-route-dateFrom=@Model.DateFrom
                   asp-route-dateTo=@Model.DateTo>
                    @Html.DisplayNameFor(model => model.Topics[0].DateOfCreation)
                </a>
            </th>
            <th>
                <a asp-controller="Topic" asp-action="Index" asp-route-sortState=@Model.AuthorSort
                   asp-route-сurrentPage=@Model.TopicPageModel.PageNumber
                   asp-route-page=@Model.Page
                   asp-route-searchKey=@Model.SearchKey
                   asp-route-author=@Model.Author
                   asp-route-dateFrom=@Model.DateFrom
                   asp-route-dateTo=@Model.DateTo>
                    @Html.DisplayNameFor(model => model.Topics[0].Author)
                </a>
            </th>
            <th>
                <a asp-controller="Topic" asp-action="Index" asp-route-sortState=@Model.TopicTitleSort
                   asp-route-сurrentPage=@Model.TopicPageModel.PageNumber
                   asp-route-page=@Model.Page
                   asp-route-searchKey=@Model.SearchKey
                   asp-route-author=@Model.Author
                   asp-route-dateFrom=@Model.DateFrom
                   asp-route-dateTo=@Model.DateTo>
                    @Html.DisplayNameFor(model => model.Topics[0].TopicTitle)
                </a>
            </th>
            <th>
                <a asp-controller="Topic" asp-action="Index" asp-route-sortState=@Model.TopicContentSort
                   asp-route-сurrentPage=@Model.TopicPageModel.PageNumber
                   asp-route-page=@Model.Page
                   asp-route-searchKey=@Model.SearchKey
                   asp-route-author=@Model.Author
                   asp-route-dateFrom=@Model.DateFrom
                   asp-route-dateTo=@Model.DateTo>
                    @Html.DisplayNameFor(model => model.Topics[0].TopicContent)
                </a>
            </th>
            <th>
                @Html.DisplayNameFor(model => model.TopicModel.PostsQty)
            </th>
            <th>
                @if (SignInManager.IsSignedIn(User))
                {
                @Html.DisplayNameFor(model => model.TopicModel.QtyUserPostsInTopic)
                }
                else
                {

                }
            </th>
            <th></th>
        </tr>
    </thead>
    <tbody>
        @foreach (var item in Model.Topics)
        {
        <tr>
            <td>
                @Html.DisplayFor(modelItem => item.DateOfCreation)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Author)
            </td>
            <td>
                <a asp-action="Index" asp-controller="PostInTopic" asp-route-topicId="@item.Id">
                    @Html.DisplayFor(modelItem => item.TopicTitle)
                </a>
            </td>
            <td>
                <a asp-action="Index" asp-controller="PostInTopic" asp-route-topicId="@item.Id">
                    @Html.DisplayFor(modelItem => item.TopicContent)
                </a>
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.PostsQty)
            </td>
            <td>
                @if (SignInManager.IsSignedIn(User))
                    {
                @Html.DisplayFor(modelItem => item.QtyUserPostsInTopic)
                    }
                    else
                    {

                    }
            </td>
            <td id="likesCount-@item.Id">
                @Html.DisplayFor(modelItem => item.Likes)
            </td>
            <td>
                <input type="button" value="Лайк" onclick="likeTopic('@item.Id')" />
            </td>
            <td id="disLikesCount-@item.Id">
                @Html.DisplayFor(modelItem => item.Dislikes)
            </td>
            <td>
                <input type="button" value="Дизлайк" onclick="disLikeTopic('@item.Id')" />
            </td>
            <td></td>
        </tr>
        }
    </tbody>
</table>


@if (Model.TopicPageModel.HasPreviousPage)
{
<a asp-action="Index"
   asp-route-name="@Model.Author"
   asp-route-dateFrom="@Model.DateFrom"
   asp-route-dateTo="@Model.DateTo"
   asp-route-sortState="@Model.TopicSortState"
   asp-route-page="@(Model.TopicPageModel.PageNumber - 1)"
   class="btn btn-outline-dark btn">
    <i class="glyphicon glyphicon-chevron-left"></i>
    Prev
</a>
}

<span style="margin: 20px">@Model.TopicPageModel.PageNumber</span>

@if (Model.TopicPageModel.HasNextPage)
{
<a asp-action="Index"
   asp-route-name="@Model.Author"
   asp-route-dateFrom="@Model.DateFrom"
   asp-route-dateTo="@Model.DateTo"
   asp-route-sortState="@Model.TopicSortState"
   asp-route-page="@(Model.TopicPageModel.PageNumber + 1)"
   class="btn btn-outline-dark btn">
    <i class="glyphicon glyphicon-chevron-right"></i>
    Next
</a>
}

<p>

</p>

@if (SignInManager.IsSignedIn(User))
{
    <div>
        <div><input type="button" id="addTopic" class="btn-primary" value="Создать тему" /></div>
        <div id="topicForm" style="display: none">
            <div>
                <p>Заголовок темы:</p>
                <textarea id="topicTitleText" class="form-control"></textarea>
            </div>
            <div>
                <p>Содержание темы:</p>
                <textarea id="topicContentText" class="form-control"></textarea>
            </div>
            <div><input type="button" id="createTopic" class="btn-primary" value="Create" /></div>
        </div>
    </div>
}
else
{

}

<br />
<p>
    <a asp-action="Index">Back to List</a>
</p>


<script>
    function likeTopic(topicId) {
        $.ajax({
            url: '@Url.Action("LikeForTopicAjax", "Topic")',
            method: 'POST',
            data: { 'topicId': topicId },
            error: function(data) {
                console.log(data);
                alert('Error' + data.status + "\n" + data.responseText);
            },
            success: function(data) {
                $('#likesCount-' + topicId).html(data);
            }
        });
    }
    function disLikeTopic(topicId) {
        $.ajax({
            url: '@Url.Action("DisLikeForTopicAjax", "Topic")',
            method: 'POST',
            data: { 'topicId': topicId },
            error: function(data) {
                console.log(data);
                alert('Error' + data.status + "\n" + data.responseText);
            },
            success: function(data) {
                $('#disLikesCount-' + topicId).html(data);
            }
        });
    }
</script>

@section Scripts
{
    <script>

        $('#addTopic').click(function () {
            //$('#topicForm').val('');
            $('#topicForm').show();
            $('#addTopic').hide();
        });

        $('#createTopic').click(function () {

            var topicTitle = $('#topicTitleText').val();
            var topicContent = $('#topicContentText').val();

            $.ajax({
                url: '@Url.Action("CreateTopicAjax", "Topic")',
                method: 'POST',
                data: { 'topicTitle': topicTitle, 'topicContent': topicContent },
                dataType: 'JSON',
                error: function (data) {
                    console.log(data);
                    alert('Error ' + data.status + "\n" + data.responseText);
                },
                success: function (data) {
                    $('#topicForm').hide();
                    $('#addTopic').show();
                    var dateOfCreationCell = "<td>" + data.dateOfCreation + "</td>";
                    var authorCell = "<td>" + data.author + "</td>";
                    var topicTitleCell = "<td>" + data.topicTitle + "</td>";
                    var topicContentCell = "<td>" + data.topicContent + "</td>";
                    var postsQtyCell = "<td>" + data.postsQty + "</td>";
                    var qtyUserPostsInTopicCell = "<td>" + data.qtyUserPostsInTopic + "</td>";
                    var likesCell = "<td>" + data.likes + "</td>";
                    var likeTopicCell = "<td>" + data.likePostInTopic + "</td>";
                    var dislikesCell = "<td>" + data.dislikes + "</td>";
                    var disLikeTopicCell = "<td>" + data.disLikePostInTopic + "</td>";
                    var newRow = "<tr>" + dateOfCreationCell + authorCell + topicTitleCell +
                        topicContentCell + topicContentCell + postsQtyCell + postsQtyCell +
                        qtyUserPostsInTopicCell + likesCell + likeTopicCell + dislikesCell +
                        + disLikeTopicCell + "</tr>";
                    $('#topicTable tbody').prepend(newRow);
                }
            });
        });

    </script>
}